    var rpc;
  RPC.READY_STATE_COMPLETE=4;
  function RPC(fe,skip_alerts) {
    if (window.XMLHttpRequest){
      this.req=new XMLHttpRequest();
    } else if (window.ActiveXObject){
      this.req=new ActiveXObject("Microsoft.XMLHTTP");
    } else {
      alert("RPC not available");
    }
    this.url=fe ? fe : "rpc_save.html";
    var req=this.req;
    if(skip_alerts){
      this.skip_alerts=skip_alerts;
      req.skip_alerts=skip_alerts;
    }
    var rpc=this;
    this.req.onreadystatechange= this.callback = function(){ 
       if (req.readyState==RPC.READY_STATE_COMPLETE){
           var httpStatus=req.status;
           if (httpStatus==200 || httpStatus==0){
                var doc = req.responseXML;
                if(!doc) {
                   if (!this.skip_alerts) alert("Cannot parse server reply :\n" + req.responseText.substr(0,256)); 
                   var cons = document.getElementById('__console'); 
                   if(cons) { cons.innerHTML += req.responseText; } 
                   return false; 
		}
                var response = doc.getElementsByTagName('response').item(0);
                if(!response) {
                   if (!this.skip_alerts) alert("Server reply has no response element " + "\n" + req.responseText);
                   return false;
                }
                var more = response.getAttribute('waitmore');
                var qid  = response.getAttribute('qid');
                var qn   = response.getAttribute('qn');
		var opts = response.getAttribute('opts');
                if(more) {
                   if(rpc.onStartWaiting) { rpc.onStartWaiting(); } 
                   document.body.style.cursor = "wait";
                   setTimeout(function() { var newrpc = new RPC(fe);
			newrpc.onEndWaiting   = rpc.onEndWaiting;
			newrpc.request('__wait',{q:qid,qn:qn,opts:opts},rpc.onOk);
		   }, parseInt(more) );
                } else {
                   var rc=response.getAttribute('rc');
                   if (rc == 'EXCEPTION') {
                     var ex = xml_getObjectAttributes(response); 
                     var func_name = 'exception_' + ex.exceptionClass.replace(/::/g,'_');
                     if(eval("window." + func_name)) { 
                       eval(func_name + "(ex)");
                     } else { 
                       alert(ex.text ? ex.text : 'произошла ошибка на сервере');
                     }
		     if(rpc.onEndWaiting) rpc.onEndWaiting(req);
                     document.body.style.cursor ='default';
                     return false;
                   }
                   if(rc == 'FAILED') { 
                       alert('произошла ошибка на сервере');
    		      if(rpc.onEndWaiting) rpc.onEndWaiting(req);
                       document.body.style.cursor ='default';
                       return false;
                   } 
                   rpc.onOk(response,req);
    		   if(rpc.onEndWaiting) rpc.onEndWaiting(req);
                   document.body.style.cursor ='auto';
                }
           } else {
                rpc.onError(req);
                document.body.style.cursor ='auto';
           }
        }
    };
  }
  RPC.prototype.onError = function(req) { 
      if (req.status == 502 && this.last_request.attempts-- > 0) {
	 var this_ = this;
	setTimeout( function() { 
		this_.request(this_.last_request.proc, this_.last_request.args,  this_.last_request.onOk, this_.last_request.sync, this_.last_request.method);
	}, 2000);
      }
      if (!this.skip_alerts) 
           if(window.console) window.console.log("error fetching data!" 
        +"\n\nreadyState:"+req.readyState
        +"\nstatus: "+req.status
        +"\nheaders: "+req.getAllResponseHeaders());
	
  }
  RPC.prototype.onOk = function() {
      if(window.console) window.console.log("Done");
  }
  RPC.prototype.request = function(proc,args,onOk,sync,method) {
      this.last_request = {
	proc: proc, args: args, onOk: onOk, sync: sync, method: method,
	attempts: 10
      };
      var qs = '';
      if (proc !== null && proc !== undefined && proc.length > 0) qs += '_proc=' + proc;
      for (var arg in args)  { var val=args[arg];
          if (typeof(val)=='object'){ for(k in val) { 
            if (val[k] && val[k].constructor != Function)
              qs+='&' + encodeURIComponent( arg ) + '=' + encodeURIComponent( val[k] );
          }}
          else { qs +='&' + encodeURIComponent( arg ) + '=' + encodeURIComponent( val ); }
      }
      var url = this.url;
      if(!method)  method = "POST";
      if(method == 'GET' && qs.length > 0) url+='?'+ qs;
      this.req.open(method, url, !sync);
      this.req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
      this.onOk = onOk;
      this.req.send(method=='GET' ? null : qs);
      if(sync) this.callback(); 
  }

  function server_call(proc,args,onOk,fe,sync,method,skip_alerts,onStartWaiting,onEndWaiting) {
     rpc = new RPC(fe,skip_alerts);
     rpc.onStartWaiting = onStartWaiting;
     rpc.onEndWaiting   = onEndWaiting;
     rpc.request(proc,args,onOk,sync,method);
  }

  function xml_getObjectAttribute(node,attrName) {
     for(var i=0;i<node.childNodes.length;i++) {
        var nn = node.childNodes[i];
        if(nn.nodeType==1) {
          if (nn.tagName==attrName) {
             return nn.childNodes[0]?nn.childNodes[0].data:null;
          }
        }
     }
     return 'KO';
  }
  function xml_getObjectAttributes(node) {
     var o = {};
     if(!node) { 
        alert("Empty node got");
        return o;
     }
     for(var i=0;i<node.attributes.length;i++) { 
        o [ node.attributes[i].nodeName ] = node.attributes[i].nodeValue;
     }
     for(var i=0;i<node.childNodes.length;i++) {
        var nn = node.childNodes[i];
        if(nn.nodeType==1) {
          if(nn.getAttribute('class')=='subobject') { 
             o[ nn.tagName  ] = null;
             for(var j=0;j<nn.childNodes.length;j++) { 
               var nnn=nn.childNodes[j];
               if(nnn.nodeType==1) { 
                  o[ nn.tagName  ] = xml_getObjectAttributes(nnn);
               }
               break;
             }
          } else 
	  if(nn.getAttribute('class')=='subobjects') {
	     o[ nn.tagName  ] = [];
	     for(var j=0;j<nn.childNodes.length;j++) {
               var nnn=nn.childNodes[j];
               if(nnn.nodeType==1) {    
                  o[ nn.tagName  ][ o[nn.tagName].length] = xml_getObjectAttributes(nnn);
               }
             }
	  } else 
          if(nn.childNodes[0]) { 
             o[ nn.tagName  ] = nn.childNodes[0].data;
          } else {
             o[ nn.tagName  ] = null;
          }
        }
     }
     return o;
  }
  function xml_getObjectList(node) { 
    var l = new Array;
    for(var i=0;i<node.childNodes.length;i++) {
        var nn = node.childNodes[i];
        if(nn.nodeType==1) {
          l[l.length] = xml_getObjectAttributes(nn);
        }
    }
    return l;
  }


  var shown = 0;
  function calendarShowHide(){
    if(shown == 1){
      $("#btnCalendar").animate({'right':'0px'}, {queue:false, duration:2000});
      $("#forCalendar").animate({'width':'0px'}, {queue:false, duration:2000, complete: function() { $("#forCalendar").css({'display':'none'}); }});
      shown = 0;
    }else{
      $("#forCalendar").css({'display':'block'});
      $("#btnCalendar").animate({'right':'250px'}, {queue:false, duration:2000 });
      $("#forCalendar").animate({'width':'250px'}, {queue:false, duration:2000 });
      shown = 1;
    }

    return false;
  }

  function redrawCalendar(month, year, selected_date, elementId, withCloseBtn){
    server_call('drawCalendar', {'month':month, 'year':year, 'selected_date':selected_date, 'elementId':elementId, 'withCloseBtn':withCloseBtn}, function(resp) { redrawCalendarCallback(resp, elementId) }, '/rpc.html');
    return false;
  }

  function redrawCalendarCallback(resp, elementId){
    var code = resp.getElementsByTagName('code')[0];
    var text = '';
    if(code){
      for(var i = 0; i < code.childNodes.length; i++){
        if(code.childNodes[i].nodeType == 3)  text += code.childNodes[i].data;
      }
    }
    document.getElementById(elementId).innerHTML = text;
  }
